			include "propeller.i"
			include "demo.i"

			org	0

SIZE			=	$fff
LFTSTART		=	$c8
LFTEND			=	$130
FOSTART			=	$140

			wrbyte	zero, =@ditherstyle
			wrlong	frontback, =@backbuf

			mov	t1, #$02
			wrbyte	t1, =@rast_colour
loop
			mov	cmd, #RAST_CLEAR
			call	#rastercall

			add	angle1, =$9
			add	angle2, =$7
			add	zaccel, =$1ff
			mov	t1, zaccel
			sub	t1, =$8000		wc
		if_nc	add	zanim, t1

			mov	sin_a, angle1
			call	#sin
			shr	sin_res, #8
			negnz	sin_a1, sin_res
			call	#cos
			shr	sin_res, #8
			negnz	cos_a1, sin_res

			mov	sin_a, angle2
			call	#sin
			shr	sin_res, #8
			negnz	sin_a2, sin_res
			call	#cos
			shr	sin_res, #8
			negnz	cos_a2, sin_res

			mov	lfsr, =$a17102f2
			mov	count, =511
triloop
			add	lfsr, #23

			mov	x0, lfsr
			and	x0, =$3fff
			shr	lfsr, #1		wc
		if_c	xor	lfsr, taps
			rol	lfsr, lfsr
			mov	y0, lfsr
			and	y0, =$3fff
			shr	lfsr, #1		wc
		if_c	xor	lfsr, taps
			ror	lfsr, lfsr

			rol	lfsr, lfsr

			mov	z0, lfsr
			and	z0, =$3fff
			shr	lfsr, #1		wc
		if_c	xor	lfsr, taps
			ror	lfsr, lfsr

			movd	p_dest1, #vertices
			movd	p_dest2, #vertices + 1

			mov	x, lfsr
			and	x, =SIZE
			add	x, x0
			max	x, =$3fff
			shr	lfsr, #1		wc
		if_c	xor	lfsr, taps
			rol	lfsr, lfsr
			mov	y, lfsr
			and	y, =SIZE
			add	y, y0
			max	y, =$3fff
			shr	lfsr, #1		wc
		if_c	xor	lfsr, taps
			ror	lfsr, lfsr
			mov	z, lfsr
			and	z, =SIZE
			add	z, z0
			max	z, =$3fff
			shr	lfsr, #1		wc
		if_c	xor	lfsr, taps
			rol	lfsr, lfsr

			call	#transform

			mov	x, lfsr
			and	x, =SIZE
			add	x, x0
			max	x, =$3fff
			shr	lfsr, #1		wc
		if_c	xor	lfsr, taps
			ror	lfsr, lfsr
			mov	y, lfsr
			and	y, =SIZE
			add	y, y0
			max	y, =$3fff
			shr	lfsr, #1		wc
		if_c	xor	lfsr, taps
			ror	lfsr, lfsr
			mov	z, lfsr
			and	z, =SIZE
			add	z, z0
			max	z, =$3fff
			shr	lfsr, #1		wc
		if_c	xor	lfsr, taps
			rol	lfsr, lfsr

			call	#transform

			mov	x, x0
			mov	y, y0
			mov	z, z0

			call	#transform

			call	#waitraster

			mov	addr, =@rast_x1
			wrword	vertices + 0, addr
			add	addr, #2
			wrword	vertices + 1, addr
			add	addr, #2
			wrword	vertices + 2, addr
			add	addr, #2
			wrword	vertices + 3, addr
			add	addr, #2
			wrword	vertices + 4, addr
			add	addr, #2
			wrword	vertices + 5, addr
			add	addr, #2

			mov	cmd, #RAST_BLENDTRI
			call	#rastercall

			djnz	count, #triloop

			call	#waitraster
fade
			add	frame, #1
			cmp	frame, =FOSTART		wc
		if_nc	add	fadecount, #2

			tjz	fadecount, #nofade
			sub	fadecount, #1

			mov	t2, fadecount
			shr	t2, #2

			mov	addr, frontback
			mov	ycount, #116
:yloop
			mov	xcount, #120
:xloop
			rdbyte	t1, addr
			sub	t1, t2
			mins	t1, #0
			wrbyte	t1, addr
			add	addr, #1
			djnz	xcount, #:xloop

			add	addr, #8
			djnz	ycount, #:yloop

nofade
			mov	t1, frame
			sub	t1, =LFTSTART		wc
		if_c	jmp	#nolft

			mov	lftfade, #$40
			sub	lftfade, t1
			sub	lftfade, t1
			mins	lftfade, #0

			mov	t1, frame
			sub	t1, =LFTEND		wc
		if_nc	mov	lftfade, t1
		if_nc	add	lftfade, t1

			mov	addr, frontback
			add	addr, =128 * 42 + 28
			mov	x, =@unpack_area
			mov	ycount, #32
:yloop
			mov	xcount, #64
:xloop
			rdbyte	t2, x
			add	x, #1
			sub	t2, lftfade	wc
		if_nc	rdbyte	t1, addr
		if_nc	add	t1, t2
		if_nc	max	t1, #$30
		if_nc	wrbyte	t1, addr

			add	addr, #1
			djnz	xcount, #:xloop

			add	addr, #64
			djnz	ycount, #:yloop

nolft
			call	#waitraster

			' swap buffers
			rol	frontback, #16
			wrlong	frontback, =@backbuf
			wrbyte	zero, =@internalvbl
:wvbl			rdbyte	t1, =@internalvbl
			tjz	t1, #:wvbl

			jmp	#loop

transform
			' x1 = x * cos(a1) - y * sin(a1)
			' y1 = x * sin(a1) + y * cos(a1)
			' z1 = z

			' x2 = x1 * cos(a2) - z1 * sin(a2)
			' y2 = y1
			' z2 = x1 * sin(a2) + z1 * cos(a2)

			sub	x, =$2000	' 8.8 in [-128, 127]
			sub	y, =$2000
			sub	z, =$2000

			mov	mulu_s, cos_a1	' 0.8 in ]-1, 1[
			mov	mulu_x, x
			call	#muls
			mov	x1, mulu_s
			mov	mulu_s, sin_a1
			mov	mulu_x, y
			call	#muls
			sub	x1, mulu_s
			sar	x1, #8		' 8.8 in [-128, 127]

			mov	mulu_s, sin_a1
			mov	mulu_x, x
			call	#muls
			mov	y1, mulu_s
			mov	mulu_s, cos_a1
			mov	mulu_x, y
			call	#muls
			add	y1, mulu_s	' 8.16 in [-128, 127]

			mov	z1, z

			mov	mulu_s, cos_a2
			mov	mulu_x, x1
			call	#muls
			mov	x, mulu_s
			mov	mulu_s, sin_a2
			mov	mulu_x, z1
			call	#muls
			sub	x, mulu_s	' 8.16 in [-128, 127]

			mov	mulu_s, sin_a2
			mov	mulu_x, x1
			call	#muls
			mov	z, mulu_s
			mov	mulu_s, cos_a2
			mov	mulu_x, z1
			call	#muls
			add	z, mulu_s	' 8.16 in [-128, 127]

			mov	y, y1

			sub	z, zanim
			shl	z, #10
			sar	z, #10

			' x, y, z as 16.16 in [-128.0, 128.0[
			' Will calculate x, y as 8.8 in [-128.0, 128.0[

			sar	z, #14			' fov
			add	z, =$00c0		' zoom

			sar	x, #1
			sar	y, #1

			mov	divu_n, x
			sar	x, #2
			sub	divu_n, x
			mov	divu_d, z
			call	#divs
p_dest1			mov	000, divu_n
			add	p_dest1, =2 << 9
			mov	divu_n, y
			mov	divu_d, z
			call	#divs
p_dest2			mov	000, divu_n
			add	p_dest2, =2 << 9

transform_ret		ret

waitraster
:wait			rdbyte	t1, =@rastercmd
			tjnz	t1, #:wait
waitraster_ret		ret

rastercall
			call	#waitraster
			wrbyte	cmd, =@rastercmd
rastercall_ret		ret

divs
			abs	divu_d, divu_d		wc
			rcl	signed, #1
			abs	divu_n, divu_n		wc
		if_c	xor	signed, #1
			call	#divu
			rcr	signed, #1		wc
			negc	divu_n, divu_n
divs_ret		ret

divu			shl	divu_d, #15
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			and	divu_n, =$ffff
divu_ret		ret

muls
			abs	mulu_x, mulu_x		wc
			rcl	signed, #1
			abs	mulu_s, mulu_s		wc
		if_c	xor	signed, #1
			call	#mulu
			shr	signed, #1		wc
			negc	mulu_s, mulu_s
muls_ret		ret

			' mulu_x[15..0] * mulu_s[7..0] -> mulu_s[23..0] (clobbers c, preserves z)
			' 4*21 cycles
mulu
			shl	mulu_x, #16
			shr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
			shr	mulu_s, #8
mulu_ret		ret

			' |sin(sin_a[12..0])| -> sin_a[15..0], (sin(sin_a[12..0]) >= 0) -> z

cos			add	sin_a, =$0800
sin			mov	sin_addr, sin_a
			test	sin_addr, =$0800	wc
			test	sin_addr, =$1000	wz
			and	sin_addr, =$07ff
		if_c	xor	sin_addr, =$07ff
			shl	sin_addr, #1
			or	sin_addr, =$e000
			rdword	sin_res, sin_addr
cos_ret
sin_ret			ret

frontback		word	@graphics0, @graphics1

taps			long	$c0000031

fadecount		long	$10 << 2
frame			long	0
zaccel			long	0
angle1			long	0
angle2			long	0
zanim			long	0

			pool

x			res	1
y			res	1
z			res	1

x0			res	1
y0			res	1
z0			res	1

x1			res	1
y1			res	1
z1			res	1

cmd			res	1
t1			res	1
t2			res	1
addr			res	1
count			res	1
xcount			res	1
ycount			res	1

lfsr			res	1

divu_n			res	1
divu_d			res	1
signed			res	1

mulu_s			res	1
mulu_x			res	1

sin_a			res	1
sin_res			res	1
sin_addr		res	1

sin_a1			res	1
cos_a1			res	1
sin_a2			res	1
cos_a2			res	1

vertices		res	6

lftfade			res	1

			vfit	496
