			include "propeller.i"
			include "demo.i"

			org	0

PITCH			=	128
HEIGHT			=	116
GLOWAMOUNT		=	$0f

main
			rdbyte	cmd, =@rastercmd
			add	cmd, #jumptable
			jmp	cmd

jumptable
			jmp	#main			' No command yet
			jmp	#clear
			jmp	#triangle
			jmp	#quad
			jmp	#glow
			jmp	#blendtexture
			jmp	#blendtri
done
			wrbyte	zero, =@rastercmd
			jmp	#main

clear
			rdword	addr, =@backbuf
			mov	ycount, #HEIGHT
:ylp			mov	xcount, #PITCH >> 2
:xlp			wrlong	zero, addr
			add	addr, #4
			djnz	xcount, #:xlp
			djnz	ycount, #:ylp
			jmp	#done

glow
			rdword	rowaddr, =@backbuf
			mov	ycount, #HEIGHT - 2
:yloop
			mov	west, #0
			mov	xcount, #PITCH
			shr	xcount, #2
			sub	xcount, #1
			add	rowaddr, #PITCH
			mov	addr, rowaddr
			mov	eaddr, addr
			add	eaddr, #4
			mov	neaddr, eaddr
			mov	seaddr, eaddr
			sub	neaddr, #PITCH
			add	seaddr, #PITCH
			rdlong	here, addr
			mov	t1, here
			shr	t1, #1
			and	here, t1

:xloop			rdlong	northeast, neaddr
			mov	t1, northeast
			shr	t1, #1
			rdlong	east, eaddr
			and	northeast, t1
			mov	t1, east
			rdlong	southeast, seaddr
			shr	t1, #1
			and	east, t1
			mov	t1, southeast
			shr	t1, #1
			and	southeast, t1

			' The above 'and' operations transform cc------ into -r------ (x4)

			or	east, northeast

			rdlong	pixels, addr

			or	east, southeast

			test	west, =$40000000		wz
	if_z		test	here, =$00004040		wz
	if_nz		add	pixels, =GLOWAMOUNT << 0

			test	here, =$00404040		wz
	if_nz		add	pixels, =GLOWAMOUNT << 8

			test	here, =$40404000		wz
	if_nz		add	pixels, =GLOWAMOUNT << 16

			test	here, =$40400000		wz
	if_z		test	east, =$00000040		wz
	if_nz		add	pixels, =GLOWAMOUNT << 24

			mov	west, here
			mov	here, east
			add	neaddr, #4

			wrlong	pixels, addr

			add	seaddr, #4
			add	eaddr, #4
			add	addr, #4
			'nop
			'nop
			djnz	xcount, #:xloop

			' For the final 4-pixel column, there's no eastern influence

			rdlong	pixels, addr

			test	west, =$40000000		wz
	if_z		test	here, =$00004040		wz
	if_nz		add	pixels, =GLOWAMOUNT << 0

			test	here, =$00404040		wz
	if_nz		add	pixels, =GLOWAMOUNT << 8

			test	here, =$40404000		wz
	if_nz		add	pixels, =GLOWAMOUNT << 16

			test	here, =$40400000		wz
	if_nz		add	pixels, =GLOWAMOUNT << 24

			wrlong	pixels, addr

			djnz	ycount, #:yloop

			jmp	#done

triangle
			mov	fillcode, #fillsegment
			call	#readtri
			call	#drawtri
			jmp	#done

blendtri
			mov	fillcode, #blendsegment
			call	#readtri
			call	#drawtri
			jmp	#done

quad
			mov	fillcode, #fillsegment
			call	#readtri
			call	#drawtri
			rdword	y1, =@rast_y1
			shl	y1, #16
			sar	y1, #22
			rdword	y2, =@rast_y3
			shl	y2, #16
			sar	y2, #22
			rdword	y3, =@rast_y4
			shl	y3, #16
			sar	y3, #22
			rdword	x1, =@rast_x1
			shl	x1, #16
			sar	x1, #6
			rdword	x2, =@rast_x3
			shl	x2, #16
			sar	x2, #6
			rdword	x3, =@rast_x4
			shl	x3, #16
			sar	x3, #6
			call	#drawtri
			jmp	#done

blendtexture
			rdword	rowaddr, =@rast_dest
			mov	y1, #0
			rdlong	stride, =@rast_stride
			mov	ystride, stride
			sar	ystride, #2
			sub	ystride, stride
:yloop
			mov	y2, y1
			shr	y2, #16
			shl	y2, #4
			add	y2, =@extra_area
			
			mov	x1, #0
			mov	addr, rowaddr
:xloop
			mov	x2, x1
			shr	x2, #16
			add	x2, y2

			rdbyte	t1, x2

			add	x1, stride

			rdbyte	t2, addr
			add	t2, t1
			max	t2, #$c0
			wrbyte	t2, addr

			add	addr, #1
			cmp	x1, =16 << 16		wc wz
		if_b	jmp	#:xloop

			add	rowaddr, #PITCH
			sub	y1, ystride
			cmp	y1, =16 << 16		wc wz
		if_b	jmp	#:yloop

			jmp	#done

readtri
			rdbyte	colour, =@rast_colour
			rdword	y1, =@rast_y1
			shl	y1, #16
			sar	y1, #22
			rdword	y2, =@rast_y2
			shl	y2, #16
			sar	y2, #22
			rdword	y3, =@rast_y3
			shl	y3, #16
			sar	y3, #22
			rdword	x1, =@rast_x1
			shl	x1, #16
			sar	x1, #6
			rdword	x2, =@rast_x2
			shl	x2, #16
			sar	x2, #6
			rdword	x3, =@rast_x3
			shl	x3, #16
			sar	x3, #6
readtri_ret		ret

drawtri
			'mov	cull, #1
			adds	x1, =1 << 22
			adds	x2, =1 << 22
			adds	x3, =1 << 22
			adds	y1, =1 << 6
			adds	y2, =1 << 6
			adds	y3, =1 << 6

			cmps	y1, y2		wc wz
		if_b	jmp	#:sort1
			'xor	cull, #1
			xor	y1, y2
			xor	y2, y1
			xor	y1, y2
			xor	x1, x2
			xor	x2, x1
			xor	x1, x2

:sort1			cmps	y1, y3		wc wz
		if_b	jmp	#:sort2
			'xor	cull, #1
			xor	y1, y3
			xor	y3, y1
			xor	y1, y3
			xor	x1, x3
			xor	x3, x1
			xor	x1, x3

:sort2			cmps	y2, y3		wc wz
		if_b	jmp	#:sort3
			'xor	cull, #1
			xor	y2, y3
			xor	y3, y2
			xor	y2, y3
			xor	x2, x3
			xor	x3, x2
			xor	x2, x3
:sort3
			mov	xstart, x1
			mov	xstop, x1

			mov	divu_n, x2
			sub	divu_n, x1
			mov	divu_d, y2
			sub	divu_d, y1
			call	#divs32
			mov	xdelta1, divu_n

			mov	divu_n, x3
			sub	divu_n, x1
			mov	divu_d, y3
			sub	divu_d, y1
			call	#divs32
			mov	xdelta2, divu_n

			mov	divu_n, x3
			sub	divu_n, x2
			mov	divu_d, y3
			sub	divu_d, y2
			call	#divs32
			mov	xdelta3, divu_n

			mov	xdelta4, xdelta2

			movd	:p_mid, #xstart
			cmps	xdelta1, xdelta2	wc wz
		if_b	jmp	#:nomirror
			'xor	cull, #1
			xor	xdelta1, xdelta2
			xor	xdelta2, xdelta1
			xor	xdelta1, xdelta2
			mov	xdelta4, xdelta3
			mov	xdelta3, xdelta1
			movd	:p_mid, #xstop
:nomirror
			'tjnz	cull, drawtri_ret

			mov	rowaddr, y1
			shl	rowaddr, #7
			rdword	addr, =@backbuf
			add	rowaddr, addr
:loop1
			cmps	y1, #HEIGHT		wc wz
		if_ae	jmp	drawtri_ret
			cmps	y1, y2			wc wz
		if_ae	jmp	#:mid
			cmps	y1, #0			wc wz
		if_b	jmp	#:clip1

			mov	addr, rowaddr
			mov	fs_x, xstart
			sar	fs_x, #16
			mov	fs_xend, xstop
			sar	fs_xend, #16
			jmpret	fillsegment_ret, fillcode
:clip1
			add	xstart, xdelta1
			add	xstop, xdelta2
			add	rowaddr, #PITCH
			add	y1, #1
			jmp	#:loop1
:mid
:p_mid			mov	xstart, x2
:loop2
			cmps	y1, #HEIGHT		wc wz
		if_ae	jmp	drawtri_ret
			cmps	y1, y3			wc wz
		if_ae	jmp	drawtri_ret
			cmps	y1, #0			wc wz
		if_b	jmp	#:clip2

			mov	addr, rowaddr
			mov	fs_x, xstart
			sar	fs_x, #16
			mov	fs_xend, xstop
			sar	fs_xend, #16
			jmpret	fillsegment_ret, fillcode
:clip2
			add	xstart, xdelta3
			add	xstop, xdelta4
			add	rowaddr, #PITCH
			add	y1, #1
			jmp	#:loop2

drawtri_ret		ret

fillsegment
			maxs	fs_xend, #127

			add	addr, fs_x
:loop
			cmps	fs_x, fs_xend	wc wz
		if_ae	jmp	fillsegment_ret

			cmps	fs_x, #0	wc wz
		if_ae	wrbyte	colour, addr

			add	fs_x, #1
			add	addr, #1
			jmp	#:loop

blendsegment
			maxs	fs_xend, #127

			add	addr, fs_x
:loop
			cmps	fs_x, fs_xend	wc wz
		if_ae	jmp	fillsegment_ret

			cmps	fs_x, #0	wc wz
		if_ae	rdbyte	t1, addr
		if_ae	add	t1, colour
		if_ae	max	t1, #$30
		if_ae	wrbyte	t1, addr

			add	fs_x, #1
			add	addr, #1
			jmp	#:loop

divs32
			sar	divu_n, #8
			abs	divu_d, divu_d		wc
			rcl	signed, #1
			abs	divu_n, divu_n		wc
		if_c	xor	signed, #1

			shl	divu_d, #15
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			and	divu_n, =$ffff

			rcr	signed, #1		wc
			negc	divu_n, divu_n
			shl	divu_n, #8
divs32_ret		ret

			pool

cmd			res	1

xcount			res	1
ycount			res	1
addr			res	1
rowaddr			res	1
colour			res	1

t1			res	1
t2			res	1
fs_x			res	1
fs_xend			res	1

x1			res	1
y1			res	1
x2			res	1
y2			res	1
x3			res	1
y3			res	1

cull			res	1

xstart			res	1
xstop			res	1

xdelta1			res	1
xdelta2			res	1
xdelta3			res	1
xdelta4			res	1

divu_n			res	1
divu_d			res	1
signed			res	1

pixels			res	1

northeast		res	1
east			res	1
southeast		res	1
here			res	1
west			res	1

eaddr			res	1
seaddr			res	1
neaddr			res	1

stride			res	1
ystride			res	1

fillcode		res	1
fillsegment_ret		res	1

			vfit	496

