			include "propeller.i"
			include "demo.i"

			org	0
LINES			=	110
FOSTART			=	310		' 330 too high (670)

			mov	t1, #DITHER_SKY
			wrbyte	t1, =@ditherstyle

			mov	addr, =16 * 16 - 4
:seedlp
			shr	lfsr, #1		wc
		if_c	xor	lfsr, taps
			wrlong	lfsr, addr
			sub	addr, #4		wc
		if_nc	jmp	#:seedlp

loop
			' Fetch a new job (line to render).

:lock			lockset	zero			wc
		if_c	jmp	#:lock
			rdword	ycount, =@nextline
			rdword	addr, =@backbuf
			mov	t1, ycount
			add	t1, #1
			wrword	t1, =@nextline
			lockclr	zero

			cmp	ycount, #LINES		wc wz
		if_b	jmp	#:doline

			' The frame is complete. Wait for the next one.

:wait			lockset	zero			wc
		if_c	jmp	#:wait
			rdword	ycount, =@nextline
			rdword	addr, =@backbuf
			cmp	ycount, #LINES		wc wz
		if_b	mov	t1, ycount
		if_b	add	t1, #1
		if_b	wrword	t1, =@nextline
			lockclr	zero
		if_ae	jmp	#:wait

			' New frame.

			add	frame, #2
			add	anim1, =1 << 7

			' Draw a line.
:doline
			neg	t1, ycount
			shl	t1, #7
			add	addr, =128 * (LINES - 1)
			add	addr, t1	

			mov	divu_n, =32 * (115 + 24)
			mov	divu_d, ycount
			add	divu_d, #24 + 115 - LINES
			call	#divu
			mov	dtb, divu_n
			shr	divu_n, #1
			mov	dsa, divu_n

			mov	fade, #$c0
			sub	fade, frame
			sub	fade, frame
			mins	fade, #0

			cmp	frame, =FOSTART		wc wz
		if_ae	mov	fade, frame
		if_ae	sub	fade, =FOSTART

			mov	dim, ycount
			xor	dim, #127
			add	dim, fade

			mov	y, ycount
			shl	y, #6

			mov	ta, y
			shr	ta, #1
			neg	sa, anim1
			shr	sa, #1
			mov	tb, #0
			neg	sb, anim1
			shr	sb, #1
			add	sb, y

			mov	t1, dsa
			shl	t1, #6
			add	sa, t1
			mov	t1, dtb
			shl	t1, #6
			add	tb, t1

			mov	xcount, #120
xloop
			mov	perlin_t, ta
			mov	perlin_s, sa
			call	#readperlin
			mov	sum, perlin_res
			add	sum, perlin_res
			mov	perlin_t, tb
			mov	perlin_s, sb
			call	#readperlin
			add	sum, perlin_res

			shr	sum, #2
			sub	sum, dim
			mins	sum, #0
			wrbyte	sum, addr

			add	addr, #1
			sub	sa, dsa
			sub	tb, dtb

			djnz	xcount, #xloop

			jmp	#loop

readperlin
			movi	perl_t_frac, perlin_t
			movi	perl_s_frac, perlin_s
			shr	perlin_t, #9
			shr	perlin_s, #9 - 4
			and	perlin_t, #$07
			and	perlin_s, #$70
			or	perlin_s, perlin_t
			rdbyte	perlin_res, perlin_s		' x0, y0
			add	perlin_s, #$10
			and	perlin_s, #$77
			rdbyte	mulu_s, perlin_s		' x1, y0
			sub	mulu_s, perlin_res

			abs	mulu_s, mulu_s		wc
			muxc	mulu_s, =1 << 8

			shr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc	' sign bit
			shr	mulu_s, #8 + 7

			shl	perlin_res, #9
			sumc	perlin_res, mulu_s

			' perlin_res is weighted sum of x0, y0 and x1, y1 in 23.9 format

			add	perlin_s, #$01
			and	perlin_s, #$77
			'nop
			rdbyte	mulu_s, perlin_s		' x1, y1
			sub	perlin_s, #$10
			and	perlin_s, #$77
			rdbyte	t1, perlin_s			' x0, y1

			sub	mulu_s, t1

			abs	mulu_s, mulu_s		wc
			muxc	mulu_s, =1 << 8

			shr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc	' sign bit
			shr	mulu_s, #8 + 7

			shl	t1, #9
			sumc	t1, mulu_s

			' t1 is weighted sum of x0, y1 and x1, y1 in 23.9 format

			sub	t1, perlin_res
			sar	t1, #9

			abs	mulu_s, t1		wc
			muxc	mulu_s, =1 << 8

			shr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_t_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_t_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_t_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_t_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_t_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_t_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_t_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_t_frac	wc
			rcr	mulu_s, #1		wc	' sign bit
			shr	mulu_s, #8 + 7

			sumc	perlin_res, mulu_s
			shr	perlin_res, #9
readperlin_ret		ret

divu			shl	divu_d, #15
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			and	divu_n, =$ffff
divu_ret		ret

lfsr			long	$12b45a76
taps			long	$c0000031

perl_s_frac		long	0
perl_t_frac		long	0

anim1			long	0
frame			long	0

			pool

t1			res	1
addr			res	1
xcount			res	1
ycount			res	1
ta			res	1
sa			res	1
tb			res	1
sb			res	1
dsa			res	1
dtb			res	1
sum			res	1
dim			res	1
y			res	1
fade			res	1

perlin_s		res	1
perlin_t		res	1
perlin_res		res	1

mulu_s			res	1
mulu_x			res	1
signed			res	1

divu_d			res	1
divu_n			res	1

			vfit	496
