			include "propeller.i"
			include "demo.i"

INTERVAL		=	45
DATA			=	128 * 128

			org	0

			mov	DIRA, #$ff
			movi	CTRA, #%0_00001_111_00000000_000000_000_000000 >> 23
			movi	FRQA, #$10000000 >> 23
			mov	VSCL, =1
			movi	VCFG, #%0_01_1_00_000_00000000000_000_0_00000000 >> 23

			mov	count, #6
:ilp			mov	rowstart, =DATA
			add	:ilp, =1 << 9
			djnz	count, #:ilp

			mov	script, =DATA
			add	script, #48

			rdlong	t1, =@nextvbl
:w			rdlong	t2, =@nextvbl
			cmp	t1, t2			wz
		if_z	jmp	#:w

			cogid	t1
			cmp	t1, #1			wz
		if_z	jmp	#sh1_vbl
			cmp	t1, #2			wz
		if_z	jmp	#sh2_vbl

wh_vbl
			mov	VSCL, #1
			rdlong	t1, =@nextvbl
			waitcnt	t1, #0
			mov	VSCL, #20
			nop
			nop
			mov	VSCL, #71
			waitvid	zero, #0

			movs	VCFG, #$08

			mov	VSCL, =5080 / 2
			mov	count, =16 * 2
:lp			waitvid	zero, #0
			djnz	count, #:lp

			movs	p_wh_row1, #rowoffset
			movs	p_wh_row2, #rowstart
			mov	rowcount, #6
wh_rowloop
			mov	VSCL, =5080 / 2
			mov	count, =2 * 2
:lp			waitvid	zero, #0
			djnz	count, #:lp

p_wh_row1		mov	sin_a, 000		' offset
			max	sin_a, =$fff
			mov	xoffset, sin_a
			shr	xoffset, #4
			test	sin_a, =$800		wc
			and	sin_a, =$7ff
		if_c	xor	sin_a, =$7ff
			shl	sin_a, #1
			or	sin_a, =$e000
			rdword	t1, sin_a
			shr	t1, #9			' [0, 127]
			sumc	xoffset, t1
		if_c	add	xoffset, =255		' nc -> linear + [0, 127], c -> linear + [128, 255]
			mov	smoothx, xoffset
			and	smoothx, #15
			shl	smoothx, #4
			shr	xoffset, #4

			mov	y, #32
			mov	fontline, #0
wh_vline
			mov	VSCL, =620
			sub	VSCL, smoothx
			waitvid	zero, #0

p_wh_row2		mov	rowaddr, 000		' start
			add	rowaddr, xoffset

			mov	x, #16
			mov	VSCL, =16 << 12 | 256
wh_xloop
			rdbyte	addr, rowaddr
			add	rowaddr, #1
			shr	addr, #1		wc
			shl	addr, #7
			add	addr, =$8000
			add	addr, fontline
			rdlong	fontbits, addr
		if_c	shr	fontbits, #1

			waitvid	wh_palette, fontbits

			djnz	x, #wh_xloop

			mov	VSCL, =620 - 256
			add	VSCL, smoothx
			waitvid	zero, #0

			add	fontline, #4
			djnz	y, #wh_vline

			mov	VSCL, =5080 / 2
			mov	count, =2 * 2
:lp			waitvid	zero, #0
			djnz	count, #:lp

			add	p_wh_row1, #1
			add	p_wh_row2, #1

			djnz	rowcount, #wh_rowloop

			movs	VCFG, #0
			call	#postframe
			jmp	#wh_vbl

sh1_vbl
			mov	VSCL, #1
			rdlong	t1, =@nextvbl
			waitcnt	t1, #0
			mov	VSCL, #20
			nop
			nop
			mov	VSCL, #71
			waitvid	zero, #0

			movs	VCFG, #$04

			movs	p_sh1_row1, #rowoffset
			movs	p_sh1_row2, #rowstart
			mov	rowcount, #3
sh1_rowloop

p_sh1_row1		mov	sin_a, 000		' offset
			max	sin_a, =$fff
			mov	xoffset, sin_a
			shr	xoffset, #4
			test	sin_a, =$800		wc
			and	sin_a, =$7ff
		if_c	xor	sin_a, =$7ff
			shl	sin_a, #1
			or	sin_a, =$e000
			rdword	t1, sin_a
			shr	t1, #9			' [0, 127]
			sumc	xoffset, t1
		if_c	add	xoffset, =255		' nc -> linear + [0, 127], c -> linear + [128, 255]
			mov	smoothx, xoffset
			and	smoothx, #15
			shl	smoothx, #4 + 1
			shr	xoffset, #4
			add	xoffset, #4

			mov	y, #64
			mov	fontline, #0
sh1_vline
			mov	VSCL, =620
			sub	VSCL, smoothx
			waitvid	zero, #0

p_sh1_row2		mov	rowaddr, 000		' start
			add	rowaddr, xoffset

			mov	x, #8
			mov	VSCL, =32 << 12 | 512
sh1_xloop
			rdbyte	addr, rowaddr
			add	rowaddr, #1
			shr	addr, #1		wc
			shl	addr, #7
			add	addr, =$8000
			add	addr, fontline
			rdlong	fontbits, addr
		if_c	shr	fontbits, #1

			waitvid	palette, fontbits

			djnz	x, #sh1_xloop

			mov	VSCL, =620 - 256
			add	VSCL, smoothx
			waitvid	zero, #0

			add	fontline, #2
			djnz	y, #sh1_vline

			mov	VSCL, =5080 / 2
			mov	count, =8 * 2
:lp			waitvid	zero, #0
			djnz	count, #:lp

			add	p_sh1_row1, #2
			add	p_sh1_row2, #2

			djnz	rowcount, #sh1_rowloop

			movs	VCFG, #0
			call	#postframe
			jmp	#sh1_vbl

sh2_vbl
			mov	VSCL, #1
			rdlong	t1, =@nextvbl
			waitcnt	t1, #0
			mov	VSCL, #20
			nop
			nop
			mov	VSCL, #71
			waitvid	zero, #0

			movs	VCFG, #$04

			mov	VSCL, =5080 / 2
			mov	count, =28 * 2
:lp			waitvid	zero, #0
			djnz	count, #:lp

			movs	p_sh2_row1, #rowoffset + 1
			movs	p_sh2_row2, #rowstart + 1
			mov	rowcount, #3
sh2_rowloop
			mov	VSCL, =5080 / 2
			mov	count, =8 * 2
:lp			waitvid	zero, #0
			djnz	count, #:lp

p_sh2_row1		mov	sin_a, 000		' offset
			max	sin_a, =$fff
			mov	xoffset, sin_a
			shr	xoffset, #4
			test	sin_a, =$800		wc
			and	sin_a, =$7ff
		if_c	xor	sin_a, =$7ff
			shl	sin_a, #1
			or	sin_a, =$e000
			rdword	t1, sin_a
			shr	t1, #9			' [0, 127]
			sumc	xoffset, t1
		if_c	add	xoffset, =255		' nc -> linear + [0, 127], c -> linear + [128, 255]
			mov	smoothx, xoffset
			and	smoothx, #15
			shl	smoothx, #4 + 1
			shr	xoffset, #4
			add	xoffset, #4

			mov	y, #64
			mov	fontline, #0
sh2_vline
			mov	VSCL, =620
			sub	VSCL, smoothx
			waitvid	zero, #0

p_sh2_row2		mov	rowaddr, 000		' start
			add	rowaddr, xoffset

			mov	x, #8
			mov	VSCL, =32 << 12 | 512
sh2_xloop
			rdbyte	addr, rowaddr
			add	rowaddr, #1
			shr	addr, #1		wc
			shl	addr, #7
			add	addr, =$8000
			add	addr, fontline
			rdlong	fontbits, addr
		if_c	shr	fontbits, #1

			waitvid	palette, fontbits

			djnz	x, #sh2_xloop

			mov	VSCL, =620 - 256
			add	VSCL, smoothx
			waitvid	zero, #0

			add	fontline, #2
			djnz	y, #sh2_vline

			add	p_sh2_row1, #2
			add	p_sh2_row2, #2

			djnz	rowcount, #sh2_rowloop

			movs	VCFG, #0
			call	#postframe
			jmp	#sh2_vbl

postframe
			movd	:p_addr, #rowoffset
			mov	count, #6
:p_addr			add	000, #20
			add	:p_addr, =1 << 9
			djnz	count, #:p_addr

			djnz	timer, postframe_ret

			rdbyte	t1, script
			cmp	t1, #7		wz
		if_z	jmp	postframe_ret
			add	script, #1
			shl	t1, #9
			add	:p_1, t1
			sub	:p_1, t1
:p_1			mov	rowstart, script
			add	:p_2, t1
			sub	:p_2, t1
:p_2			mov	rowoffset, #0
			add	script, #48
			mov	timer, =INTERVAL

postframe_ret		ret

palette			byte	0, $04, 0, $04
wh_palette		byte	0, $08, 0, $08

			pool

timer			long	1

rowstart		long	0[6]
rowoffset		long	0[6]

rowcount		res	1
count			res	1
addr			res	1
rowaddr			res	1
t1			res	1
t2			res	1
x			res	1
y			res	1
fontbits		res	1
fontline		res	1
xoffset			res	1
smoothx			res	1
script			res	1

sin_a			res	1
sin_res			res	1

			vfit	496
