			include "propeller.i"
			include "demo.i"

PINMASK		=	$03
ZOOMSTART	=	$100
XYSTART		=	$120
ROTSTART	=	$200
SKEWSTART	=	$240

			org	0

			mov	DIRA, #PINMASK

			rdlong	t1, =@nextvbl
:w			rdlong	t2, =@nextvbl
			cmp	t1, t2			wz
		if_z	jmp	#:w

vbl
			rdlong	t1, =@nextvbl
			add	t1, =0*5080+681

			add	frame, #1
			cmp	frame, =ROTSTART	wc wz
		if_ae	add	anglephase, =$000f
			cmp	frame, =ZOOMSTART	wc wz
		if_ae	add	zoomphase, =$0022
			cmp	frame, =XYSTART		wc wz
		if_ae	add	dorigin, =$00001000
		if_ae	max	dorigin, =$00050001
		if_ae	add	origin, dorigin

			mov	sin_a, anglephase
			call	#sin
			shr	mulu_x, #11
			sumnz	angle, mulu_x

			mov	sin_a, zoomphase
			call	#sin
			negnz	zoom, mulu_x
			sar	zoom, #10
			add	zoom, #$80

			mov	sin_a, angle
			call	#sin
			mov	mulu_s, zoom
			call	#mulu
			shr	mulu_s, #14
			negnz	sinpart, mulu_s

			mov	sin_a, angle
			call	#cos
			mov	mulu_s, zoom
			call	#mulu
			shr	mulu_s, #14
			negnz	cospart, mulu_s

			mov	preskew_y, sinpart
			mov	preskew_x, cospart

			sar	sinpart, #1
			sar	cospart, #1

			mov	rowxy, cospart
			sar	cospart, #2
			sub	rowxy, cospart
			shl	rowxy, #16
			add	rowxy, sinpart
			sar	sinpart, #2
			sub	rowxy, sinpart
			rol	rowxy, #8

			mov	xystart, origin
			mov	sin_a, frame
			sub	sin_a, =SKEWSTART
			mins	sin_a, #0
			mov	skew_angle, sin_a
			shl	skew_angle, #3
			call	#sin
			negnz	skew_dangle, mulu_x
			sar	skew_dangle, #11

			mov	ycount, #240
vline
			mov	sin_a, skew_angle
			call	#sin
			negnz	mulu_s, mulu_x
			sar	mulu_s, #11
			add	mulu_s, =$80		' in [$60, $a0]
			mov	t2, mulu_s

			add	skew_angle, skew_dangle

			abs	mulu_x, preskew_y	wc
			rcl	signed, #1
			call	#mulu
			shr	mulu_s, #7
			shr	signed, #1		wc

			negnc	deltaxy, mulu_s

			shl	deltaxy, #16

			mov	mulu_s, t2
			abs	mulu_x, preskew_x	wc
			rcl	signed, #1
			call	#mulu
			shr	mulu_s, #7
			shr	signed, #1		wc

			sumc	deltaxy, mulu_s
			rol	deltaxy, #8

			neg	xy, deltaxy
			rol	xy, #6
			add	xy, xystart
			waitcnt	t1, =5080

			mov	xcount, #120
:lp
			mov	addr, xy			' ---------xxxxxxx---------yyyyyyy
			movi	addr, addr			' --yyyyyyyxxxxxxx----------------
			shl	addr, #2			' yyyyyyyxxxxxxx----------------00
			shr	addr, #18			' 000000000000000000yyyyyyyxxxxxxx

			rdbyte	OUTA, addr

			addx	xy, deltaxy		wc
			djnz	xcount, #:lp

			rcr	savecarry, #1		wc
			test	ycount, #3		wz
			addx	xystart, rowxy		wc
			rcl	savecarry, #1		wc

			djnz	ycount, #vline

			jmp	#vbl

			' mulu_x[15..0] * mulu_s[7..0] -> mulu_s[23..0] (clobbers c, preserves z)
			' 4*21 cycles
mulu
			shl	mulu_x, #16
			shr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
			shr	mulu_s, #8
mulu_ret		ret

			' |sin(sin_a[12..0])| -> sin_a[15..0], (sin(sin_a[12..0]) >= 0) -> z

cos			add	sin_a, =$0800
sin			test	sin_a, =$0800		wc
			test	sin_a, =$1000		wz
			and	sin_a, =$07ff
		if_c	xor	sin_a, =$07ff
			shl	sin_a, #1
			or	sin_a, =$e000
			rdword	mulu_x, sin_a
cos_ret
sin_ret			ret

zoomphase		long	$1900
origin			long	$00400052
dorigin			long	$00000001
frame			long	0
angle			long	0
anglephase		long	0
skew_dangle		long	0

savecarry		long	0

			pool

t1			res	1
t2			res	1
xcount			res	1
ycount			res	1
addr			res	1
delay			res	1
xy			res	1
xystart			res	1
deltaxy			res	1
rowxy			res	1
sinpart			res	1
cospart			res	1
zoom			res	1

sin_a			res	1
skew_angle		res	1

mulu_x			res	1
mulu_s			res	1
signed			res	1

preskew_x		res	1
preskew_y		res	1

			vfit	496
